<?php
/*
Plugin Name: BIM-ba
Plugin URI: http://www.andywar.net/wordpress-plugins/bim-ba/
Description: A very basic Building Information Modeling
Version: 2.2.0
Author: andywar65
Author URI: http://www.andywar.net/
License: GPLv2
Text Domain: bim-ba
*/

/*  Copyright 2015-2017  Andrea Guerra  (email : me@andywar.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
 * ACTIVATION
*/

register_activation_hook(__FILE__, 'bimba_activate');//registers plugin activation

function bimba_activate() {//plugin activation
	bimba_textdomain();
	//activate next line if you really want to use Studio Management package
	//register_gestudio_cpt_tax();//registers cpt and taxonomy for studiomng package
	bimba_3d_ambient_register_cpt();
	bimba_3d_ambient_register_taxonomies();
	flush_rewrite_rules();
	bimba_fix_old_version_meta();
	bimba_insert_generic_materials();
}

/*
 * INITIALIZE
*/


/*
 * CONSTANTS
*/

define('BIMBA_PLUGIN_VERSION', '2.2.0');
define('BIMBA_PLUGIN_SLUG', 'bim-ba');

define('BIMBA_DS', DIRECTORY_SEPARATOR);
define('BIMBA_PLUGIN_DIR', dirname( __FILE__ ) );
define('BIMBA_PLUGIN_LIB_DIR', BIMBA_PLUGIN_DIR . BIMBA_DS . 'lib');

/*
 * INTERNATIONALIZATION
*/

add_action ( 'init' , 'bimba_textdomain' );

function bimba_textdomain(){
	if (!load_plugin_textdomain( 'bim-ba', false, dirname( plugin_basename(__FILE__) ).'/languages/') ){
		load_plugin_textdomain( 'bim-ba', false, dirname( plugin_basename(__FILE__) ).'/languages/');
	}
	
}

/*
 * LIBRARIES
*/

//activate next lines if you really want to use Studio Management package
//require_once BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . 'gestudio.php';
//require_once BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . 'gestudio-settings-page.php';//loads Studio Management package
//require_once BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . 'gestudio-operatori.php';
//require_once BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . 'gestudio-lavori.php';
//require_once BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . 'gestudio-rapporti.php';
//require_once BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . 'gestudio-prime-note.php';
require_once BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . '3d-ambient-metabox.php';
require_once BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . '3d-ambient.php';
require_once BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . 'steel-deck.php';

add_action ( 'plugins_loaded' , 'check_if_cmb2_existing' );

function check_if_cmb2_existing(){
	if( !class_exists( 'CMB2' ) AND file_exists( BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . 'cmb2/init.php' ) ){
		require_once BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . 'cmb2/init.php';
	}
	if( !class_exists( 'CMB2_Conditionals' ) AND file_exists( BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . 'cmb2-conditionals/cmb2-conditionals.php' ) ){
		require_once BIMBA_PLUGIN_LIB_DIR . BIMBA_DS . 'cmb2-conditionals/cmb2-conditionals.php';
		if ( is_admin() ) {
			wp_enqueue_script( 'bimba-cmb2-conditionals', $src = plugins_url( 'lib/cmb2-conditionals/cmb2-conditionals.js', __FILE__ ) );//file was not loaded by plugin itself
		}
	}
}

if ( ! is_admin() ) {//
	wp_enqueue_script( 'bimba-aframe', $src = plugins_url( 'js/aframe.min.js', __FILE__ ) );//insert js libraries in head of document (version 0.4.0)
	//wp_enqueue_script( 'bimba-look-at', $src = plugins_url( 'js/aframe-look-at-component.min.js', __FILE__ ) );
	//wp_enqueue_script( 'bimba-camera-fly', $src = plugins_url( 'js/bimba-camera-fly.js', __FILE__ ), $in_footer = true );//TODO
}

/*
 * ACTIVATION PROCEDURES
*/

function register_gestudio_cpt_tax(){
	
	//registra taxonomy categoria contabile del cpt prime note
	register_taxonomy('categoria-contabile' , 'prime-note', array ( 'hierarchical' => true, 'label' => __('Counting Category','bim-ba'),
	'query-var' => true,'rewrite' => true));
	
	$terms = array (__('Incomes','bim-ba'),
					__('Expenses','bim-ba'),
					__('Clearances','bim-ba') );
	foreach ( $terms as $term ){
		if ( !term_exists( $term, 'categoria-contabile' ) ){
			wp_insert_term( $term, 'categoria-contabile' );
		}
	}
	
	$parent_term_id = term_exists(__('Incomes','bim-ba'), 'categoria-contabile' );
	
	if ( !term_exists( __('Anticipations','bim-ba'), 'categoria-contabile' ) ){
		wp_insert_term( 'Anticipations', 'categoria-contabile', array('slug' => 'anticipations', 'parent'=> $parent_term_id['term_id']));
	}
	
	$parent_term_id = term_exists(__('Expenses','bim-ba'), 'categoria-contabile' );
	
	$terms = array (
			array(__('01-Taxes','bim-ba'),__('taxes','bim-ba')),
			array(__('02-Profits','bim-ba'),__('profits','bim-ba')),
			array(__('03-Restitutions','bim-ba'),__('restitutions','bim-ba')),
			array(__('04-Social Security','bim-ba'),__('social-security','bim-ba')),
			array(__('05-Salaries','bim-ba'),__('salaries','bim-ba')),
			array(__('06-Internal Contributors','bim-ba'),__('internal-contributors','bim-ba')),
			array(__('07-External Contributors','bim-ba'),__('external-contributors','bim-ba')),
			array(__('08-Loans','bim-ba'),__('loans','bim-ba')),
			array(__('09-Energy Supplies','bim-ba'),__('energy-supplies','bim-ba')),
			array(__('10-Communications','bim-ba'),__('communications','bim-ba')),
			array(__('11-Assistence','bim-ba'),__('assistence','bim-ba')),
			array(__('12-Office Supplies','bim-ba'),__('office-supplies','bim-ba')),
			array(__('13-Fleet','bim-ba'),__('fleet','bim-ba')),
			array(__('14-Policies','bim-ba'),__('policies','bim-ba')),
			array(__('15-Other','bim-ba'),__('other','bim-ba'))
	);
	foreach ( $terms as $term ){
		if ( !term_exists( $term[0], 'categoria-contabile' ) ){
			wp_insert_term( $term[0], 'categoria-contabile', array('slug' => $term[1], 'parent'=> $parent_term_id['term_id']));
		}
	}
	
	//registra taxonomy qualifiche del cpt operatori
	
	register_taxonomy('gstu-ruoli' , 'gstu-operatori', array ( 'hierarchical' => true, 'label' => __("Role of Operator", 'bim-ba' ),
		  'query-var' => true,'rewrite' => true));
	
	$terms = array (__('Studio','bim-ba'),
			__('Contributor','bim-ba'),
			__('Client','bim-ba'),
			__('Contractor','bim-ba'),
			__('Bank','bim-ba') );
	foreach ( $terms as $term ){
		if ( !term_exists( $term, 'gstu-ruoli' ) ){
			wp_insert_term( $term, 'gstu-ruoli' );
		}
	}
	
	//registra taxonomy fase del cpt lavori
	
	register_taxonomy('gstu-fasi' , 'gstu-lavori', array ( 'hierarchical' => true, 'label' => __('Fase di Lavorazione', 'bim-ba' ),
		  'query-var' => true,'rewrite' => true));
	
	$terms = array (__('01-Inquest','bim-ba'),
			__('02-Draft','bim-ba'),
			__('03-Final Project','bim-ba'),
			__('04-Executive project','bim-ba'),
			__("05-Tender Invitation",'bim-ba'),
			__("06-Contract",'bim-ba'),
			__('07-Project Management','bim-ba'),
			__('08-Trials','bim-ba') );
	foreach ( $terms as $term ){
		if ( !term_exists( $term, 'gstu-fasi' ) ){
			wp_insert_term( $term, 'gstu-fasi' );
		}
	}
	
	//registra taxonomy fase del cpt rapporti
	
	register_taxonomy('gstu-tipi' , 'gstu-rapporti', array ( 'hierarchical' => true, 'label' => __('Type of Report', 'bim-ba' ),
		  'query-var' => true,'rewrite' => true));
	
	$terms = array (
			__('Draft Bill','bim-ba'),
			__('Final Bill','bim-ba'),
			__('Fee','bim-ba'),
			__('Invoice','bim-ba'),
			__('Credit','bim-ba') );
	foreach ( $terms as $term ){
		if ( !term_exists( $term, 'gstu-tipi' ) ){
			wp_insert_term( $term, 'gstu-tipi' );
		}
	}
}

/*
 * INITIALIZE
*/

add_action('init', 'bimba_3d_ambient_register_cpt');

function bimba_3d_ambient_register_cpt(){
	$labels = array(
			'name' => esc_html__( '3D Ambients', 'bim-ba' ),
			'singular_name' => esc_html__( '3D Ambient', 'bim-ba' ),
			'add_new' => esc_html__( 'Add New', 'bim-ba' ),
			'add_new_item' => esc_html__( 'Add 3D Ambient', 'bim-ba' ),
			'edit_item' => esc_html__( 'Modify 3D Ambient', 'bim-ba' ),
			'new_item' => esc_html__( 'New 3D Ambient', 'bim-ba' ),
			'all_items' => esc_html__( 'All 3D Ambients', 'bim-ba' ),
			'view_item' => esc_html__( 'Wiev 3D Ambient', 'bim-ba' ),
			'search_items' => esc_html__( 'Search 3D Ambient', 'bim-ba' ),
			'not_found' =>  esc_html__( 'No 3D Ambient', 'bim-ba' ),
			'not_found_in_trash' => esc_html__( 'No 3D Ambient in Trash', 'bim-ba' ),
			'menu_name' => 'BIM-ba'
	);

	$args = array(
			'hierarchical' => true,
			'labels' => $labels,
			'public' => true,
			'publicly_queryable' => true,
			'show_ui' => true,
			'show_in_menu' => true,
			'query_var' => true,
			'rewrite' => array('slug' => _x('3d-ambient', 'URL slug', 'bim-ba')),
			'capability_type' => 'page',
			'has_archive' => true,
			'menu_position' => 100,
			'supports' => array( 'title', 'editor', 'content', 'thumbnail', 'page-attributes', 'comments', 'author' ),
			'menu_icon'   => 'dashicons-layout'
	);

	register_post_type( 'bimba_3d_ambient', $args );

	$labels = array(
			'name' => esc_html__( '3D Materials', 'bim-ba' ),
			'singular_name' => esc_html__( '3D Material', 'bim-ba' ),
			'add_new' => esc_html__( 'Add New', 'bim-ba' ),
			'add_new_item' => esc_html__( 'Add 3D Material', 'bim-ba' ),
			'edit_item' => esc_html__( 'Modify 3D Material', 'bim-ba' ),
			'new_item' => esc_html__( 'New 3D Material', 'bim-ba' ),
			'all_items' => esc_html__( 'All 3D Materials', 'bim-ba' ),
			'view_item' => esc_html__( 'Wiev 3D Material', 'bim-ba' ),
			'search_items' => esc_html__( 'Search 3D Material', 'bim-ba' ),
			'not_found' =>  esc_html__( 'No 3D Material', 'bim-ba' ),
			'not_found_in_trash' => esc_html__( 'No 3D Material in Trash', 'bim-ba' ),
			//'menu_name' => __( 'BIM-ba', 'bim-ba' )
	);

	$args = array(
			'hierarchical' => true,
			'labels' => $labels,
			'public' => true,
			'publicly_queryable' => true,
			'show_ui' => true,
			'show_in_menu' => 'edit.php?post_type=bimba_3d_ambient',
			'query_var' => true,
			'rewrite' => array('slug' => _x('3d-material', 'URL slug', 'bim-ba')),
			'capability_type' => 'page',
			'has_archive' => true,
			'menu_position' => 100,
			'supports' => array( 'title', 'editor', 'content', 'thumbnail', 'page-attributes', 'comments', 'author' ),
			'taxonomies' => array( 'material_category' , ),
			//'menu_icon'   => 'dashicons-layout'
	);

	register_post_type( 'bimba_3d_material', $args );
	
	register_taxonomy('material_category' , 'bimba_3d_material', array ( 'hierarchical' => true, 'label' => __('Material Category','bim-ba'),
	'query-var' => true,'rewrite' => true));
}

function bimba_3d_ambient_register_taxonomies(){
	register_taxonomy('material_category' , 'bimba_3d_material', array ( 'hierarchical' => true, 'label' => __('Material Category','bim-ba'),
	'query-var' => true,'rewrite' => true));
	
	$terms = array ( 
			array ( 'name' => esc_html__('Pavements','bim-ba'), 'slug' => 'pavements', ),
			array ( 'name' => esc_html__('Walls','bim-ba'), 'slug' => 'walls', ),
			array ( 'name' => esc_html__('Tiling','bim-ba'), 'slug' => 'tiling', ),
			array ( 'name' => esc_html__('Frames','bim-ba'), 'slug' => 'frames', ),
	);
	foreach ( $terms as $term ){
		if ( !term_exists( $term [ 'name' ] , 'material_category' ) ){
			wp_insert_term( $term [ 'name' ], 'material_category', array( 'slug' => $term [ 'slug' ], ) );
		}
	}
}

add_action( 'admin_menu', 'bimba_3d_material_taxonomy_submenu' );

function bimba_3d_material_taxonomy_submenu() {
	add_submenu_page(
		'edit.php?post_type=bimba_3d_ambient',
		'Material Categories',
		esc_html__('Material Categories', 'bim-ba'),
		'manage_options',
		'edit-tags.php?taxonomy=material_category&post_type=bimba_3d_material'
				//, array( $this, 'create_admin_page' )
		);
}

function bimba_fix_old_version_meta(){//fixing meta from old versions
	
	$args = array(
			'post_type'   => 'bimba_3d_material', 
			'numberposts' => -1,
		);
	
	$posts = get_posts( $args );
	
	if ( $posts ) {
		foreach ( $posts as $post ) {
			//material image
			$old_post_meta = get_post_meta( $post->ID, '_3d_material_image', true );
			if ( $old_post_meta ) {
				update_post_meta( $post->ID, '_3d_material_render' , array( '0' => array( 'image' => $old_post_meta ) ) );
				delete_post_meta( $post->ID, '_3d_material_image' );
			}
		}
	}
	
	$args = array(
			'post_type'   => 'bimba_3d_ambient',
			'numberposts' => -1,
	);
	
	$posts = get_posts( $args );
	
	if ( $posts ) {
		foreach ( $posts as $post ) {
			//global positioning
			$old_post_meta_rot = get_post_meta( $post->ID, '_3d_ambient_global_rot', true );
			$old_post_meta_x = get_post_meta( $post->ID, '_3d_ambient_global_x', true );
			$old_post_meta_z = get_post_meta( $post->ID, '_3d_ambient_global_z', true );
			if ( $old_post_meta_rot OR $old_post_meta_x OR $old_post_meta_z ) {
				update_post_meta( $post->ID, '_3d_ambient_global_diff' , array( '0' => array(
					'rot' => $old_post_meta_rot,
					'x' => $old_post_meta_x,
					'z' => $old_post_meta_z,	
				 ) ) );
				delete_post_meta( $post->ID, '_3d_ambient_global_rot' );
				delete_post_meta( $post->ID, '_3d_ambient_global_x' );
				delete_post_meta( $post->ID, '_3d_ambient_global_z' );
			}
			
			//room general settings
			$height = get_post_meta( $post->ID, '_3d_ambient_room_height', true );
			$wall_material = get_post_meta( $post->ID, '_3d_ambient_wall_material', true );
			$tiling_material = get_post_meta( $post->ID, '_3d_ambient_tiling_material', true );
			$floor_image = get_post_meta( $post->ID, '_3d_ambient_floor_image', true );
			$floor_material = get_post_meta( $post->ID, '_3d_ambient_floor_material', true );
			$skirting_height = get_post_meta( $post->ID, '_3d_ambient_skirting_height', true );
			
			if ( $height OR $wall_material OR $tiling_material OR $floor_image OR $floor_material OR $skirting_height ) {
				update_post_meta( $post->ID, '_3d_ambient_general_settings' , array( '0' => array(
				'height' 			=> $height,
				'wall_material' 	=> $wall_material,
				'tiling_material' 	=> $tiling_material,
				'floor_image' 		=> $floor_image,
				'floor_material' 	=> $floor_material,
				'skirting_height' 	=> $skirting_height,
				) ) );
				
				delete_post_meta( $post->ID, '_3d_ambient_room_height' );
				delete_post_meta( $post->ID, '_3d_ambient_wall_material' );
				delete_post_meta( $post->ID, '_3d_ambient_tiling_material' );
				delete_post_meta( $post->ID, '_3d_ambient_floor_image' );
				delete_post_meta( $post->ID, '_3d_ambient_floor_material' );
				delete_post_meta( $post->ID, '_3d_ambient_skirting_height' );
				
				delete_post_meta( $post->ID, '_3d_ambient_room_color' );
				delete_post_meta( $post->ID, '_3d_ambient_floor_color' );
				delete_post_meta( $post->ID, '_3d_ambient_tiling_color' );
				delete_post_meta( $post->ID, '_3d_ambient_sk_color' );
				
			}
			
		}
	}
}

function bimba_insert_generic_materials() {
	
	$args = array(
			'post_type'   => 'bimba_3d_material',
			'name' => 'generic-door',
			'post_status' 	=> 'publish',
	);
	
	if ( ! get_posts( $args ) ) {
		$term = term_exists( esc_html__('Frames','bim-ba'), 'material_category' );//the material category is hierarchical, so we have to retreive the id of the term
		$args = array(
			'post_type' 	=> 'bimba_3d_material',
			'post_title' 	=> esc_html__('Generic Door', 'bim-ba'),
			'post_name' 	=> 'generic-door',
			'post_status' 	=> 'publish',
			'post_content' 	=> esc_html__('Just a generic door 3D Material to start with.', 'bim-ba'),
			'tax_input' 	=> array( 'material_category' => array( $term[ 'term_taxonomy_id' ] ), ),
			'meta_input' 	=> array( '_3d_material_render' => array( '0' => array( 'image' => plugins_url( 'images/door.png', __FILE__ ), 'color'=>'#ffffff' ) ), ),
		);
		wp_insert_post($args);
	}
	
	$args = array(
			'post_type'   => 'bimba_3d_material',
			'name' => 'generic-window',
			'post_status' 	=> 'publish',
	);
	
	if ( ! get_posts( $args ) ) {
		$term = term_exists( esc_html__('Frames','bim-ba'), 'material_category' );
		$args = array(
				'post_type' 	=> 'bimba_3d_material',
				'post_title' 	=> esc_html__('Generic Window', 'bim-ba'),
				'post_name' 	=> 'generic-window',
				'post_status' 	=> 'publish',
				'post_content' 	=> esc_html__('Just a generic window 3D Material to start with.', 'bim-ba'),
				'tax_input' 	=> array( 'material_category' => array( $term[ 'term_taxonomy_id' ] ), ),
				'meta_input' 	=> array( '_3d_material_render' => array( '0' => array( 'image' => plugins_url( 'images/window.png', __FILE__ ), 'color'=>'#ffffff' ) ), ),
		);
		wp_insert_post($args);
	}
	
	$args = array(
			'post_type'   => 'bimba_3d_material',
			'name' => 'generic-tiling',
			'post_status' 	=> 'publish',
	);
	
	if ( ! get_posts( $args ) ) {
		$term = term_exists( esc_html__('Pavements','bim-ba'), 'material_category' );
		$term_2 = term_exists( esc_html__('Tiling','bim-ba'), 'material_category' );
		$args = array(
				'post_type' 	=> 'bimba_3d_material',
				'post_title' 	=> esc_html__('Generic Tiling', 'bim-ba'),
				'post_name' 	=> 'generic-tiling',
				'post_status' 	=> 'publish',
				'post_content' 	=> esc_html__('Just a generic tiling 3D Material to start with.', 'bim-ba'),
				'tax_input' 	=> array( 'material_category' => array( $term[ 'term_taxonomy_id' ], $term_2[ 'term_taxonomy_id' ] ), ),
				'meta_input' 	=> array( '_3d_material_render' => array( '0' => array( 'image' => plugins_url( 'images/tiling.png', __FILE__ ), 'color'=>'#ffffff' ) ), ),
		);
		wp_insert_post($args);
	}
	
	$args = array(
			'post_type'   => 'bimba_3d_material',
			'name' => 'generic-wall',
			'post_status' 	=> 'publish',
	);
	
	if ( ! get_posts( $args ) ) {
		$term = term_exists( esc_html__('Walls','bim-ba'), 'material_category' );
		$args = array(
				'post_type' 	=> 'bimba_3d_material',
				'post_title' 	=> esc_html__('Generic Wall', 'bim-ba'),
				'post_name' 	=> 'generic-wall',
				'post_status' 	=> 'publish',
				'post_content' 	=> esc_html__('Just a generic wall 3D Material to start with.', 'bim-ba'),
				'tax_input' 	=> array( 'material_category' => array( $term[ 'term_taxonomy_id' ], ), ),
				'meta_input' 	=> array( '_3d_material_render' => array( '0' => array( 'image' => plugins_url( 'images/wall.png', __FILE__ ), 'color'=>'#ffffff' ) ), ),
		);
		wp_insert_post($args);
	}
	
	$args = array(
			'post_type'   => 'bimba_3d_material',
			'name' => 'generic-skirting',
			'post_status' 	=> 'publish',
	);
	
	if ( ! get_posts( $args ) ) {
		$term = term_exists( esc_html__('Tiling','bim-ba'), 'material_category' );
		$args = array(
				'post_type' 	=> 'bimba_3d_material',
				'post_title' 	=> esc_html__('Generic Skirting', 'bim-ba'),
				'post_name' 	=> 'generic-skirting',
				'post_status' 	=> 'publish',
				'post_content' 	=> esc_html__('Just a generic skirting 3D Material to start with.', 'bim-ba'),
				'tax_input' 	=> array( 'material_category' => array( $term[ 'term_taxonomy_id' ], ), ),
				'meta_input' 	=> array( '_3d_material_render' => array( '0' => array( 'image' => plugins_url( 'images/skirting.png', __FILE__ ), 'color'=>'#ffffff' ) ), ),
		);
		wp_insert_post($args);
	}
	
}